﻿using System;

namespace Events
{
    class Program
    {
        static void Main()
        {
            var source = new Eventful();
            source.Announcement += m => Console.WriteLine("Zdarzenie Announcement: " + m);
        }

        // Ten przykład pokazuje rozwiązanie, którego nie należy stosować. Aby zobaczyć
        // błąd kompilacji, zmień #if false na #if true
#if false
        public static void HowNotToRaiseAnEvent()
        {
            var source = new Eventful();
            source.Announcement("Czy to zadziala?"); // Nie, tego kodu nie uda się skompilować!
        }
#endif

        // Ten przykład pokazuje typ definiowany przez system operacyjny. Ponieważ jest on
        // zdefiniowany w bibliotece klas .NET, nie trzeba definiować go samodzielnie; stąd 
        // użycie dyrektywy #if false
#if false
        public delegate void EventHandler(object sender, EventArgs e);
#endif
    }
}